#include <ch32v00x.h>

#include "log_debug.h"
#include "uptime.h"

#include "mod_io2.h"

#ifdef __cplusplus
extern "C" {
#endif
	void NMI_Handler(void)       __attribute__((interrupt("WCH-Interrupt-fast")));
	void HardFault_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
#ifdef __cplusplus
}
#endif

int main(void) {
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	SystemCoreClockUpdate();
	
	// Disable GPIO Alternate Functions and extrnal oscilator
	// Othewize GPIO PORT A does not work
	RCC_HSEConfig(RCC_HSE_OFF);
	GPIO_PinRemapConfig(GPIO_Remap_PA1_2, DISABLE);

	Uptime_Init();
	LOG_DEBUG_Configure(115200, USART_StopBits_1, USART_Parity_No);

	LOG_DEBUG(EOL "Sys Clock: %ld" EOL, SystemCoreClock);

	MOD_IO2::Setup();
	while (1) {
	}
}

void NMI_Handler(void) {
	LOG_DEBUG("NMI_Handler" EOL);
}

void HardFault_Handler(void) {
	LOG_DEBUG("HardFault_Handler" EOL);
	while (1) {
		
	}
}
